import 'package:koin/koin.dart';
import 'package:meta/meta.dart';
import 'package:test/test.dart';

import 'check/check_module_dsl.dart';
import 'check/check_modules.dart';

@isTest
void testModule(
  String description,
  Module module, {
  CheckParameters checkParameters,
  String testOn,
  Timeout timeout,
  dynamic skip,
  dynamic tags,
  Map<String, dynamic> onPlatform,
  int retry,
}) {
  test(description, () {
    checkModules([module], checkParameters);
  },
      testOn: testOn,
      tags: tags,
      timeout: timeout,
      skip: skip,
      retry: retry,
      onPlatform: onPlatform);
}

@isTest
void testModules(String description,
    {List<Module> modules,
    CheckParameters checkParameters,
    String testOn,
    Timeout timeout,
    dynamic skip,
    dynamic tags,
    Map<String, dynamic> onPlatform,
    int retry}) {
  test(description, () {
    if (checkParameters == null) {
      checkParameters = CheckParameters();
    }
    checkModules(modules, checkParameters);
  },
      testOn: testOn,
      tags: tags,
      timeout: timeout,
      skip: skip,
      retry: retry,
      onPlatform: onPlatform);
}
